=== modified file 'sql/field.cc'
--- sql/field.cc	2014-10-20 12:42:00 +0000
+++ sql/field.cc	2014-11-03 07:15:23 +0000
@@ -1246,6 +1246,66 @@ double Field::pos_in_interval_val_str(Fi
 }
 
 
+/*
+  This handles all numeric and BIT data types.
+*/
+bool Field::can_optimize(const Tool &tool,
+                         const Item_func *cond, const Item *arg)
+{
+  DBUG_ASSERT((tool.key_flags() & HA_SPATIAL) == 0);
+  DBUG_ASSERT(cmp_type() != STRING_RESULT);
+  /*
+    Can't optimize a date/datetime/timestamp condition on a numeruc column,
+    as mapping from numbers to date/datetime/timestamp is not linear and
+    not consistent:
+    - Different numeric values can map to the same temporal value
+      (990101 and 19990101 map to DATE'1999-01-01')
+    - Bad values like -1 and 99991232 (notice bad day) are equal to zero date:
+         SELECT DATE'0000-00-00'=-1;        -> 1
+         SELECT DATE'0000-00-00'=99991232;  -> 1
+      The same for time:
+         SELECT TIME'00:00:00'=99991231;    -> 1
+    - Numbers and temporal values can be compared differently in different
+      context (e.g. mdev-6983).
+    Also, can't optimize a string condition on a numeric column.
+    Allow only conditions on numeric data types.
+  */
+  if (cond->compare_type() != INT_RESULT &&
+      cond->compare_type() != DECIMAL_RESULT  &&
+      cond->compare_type() != REAL_RESULT )
+    return false;
+
+  switch (tool.type())
+  {
+  case TOOL_KEYPART_RANGE:
+    return tool.optimize_range(table);
+  case TOOL_KEY_GROUP_MIN_MAX:
+  case TOOL_PARTITION_RANGE:
+  case TOOL_SELECTIVITY:
+    return true;
+  case TOOL_EQUALITY_FOR_OUTER_JOIN_TABLE_ELIMINATION:
+  case TOOL_KEYPART_RANGE_TRIVIAL:
+  case TOOL_KEYPART_REF:
+  case TOOL_PARTITION_REF:
+  case TOOL_HASH_JOIN:
+    /*
+      This fixes MDEV-6969 and MDEV-6986 but breaks some existing tests.
+      Needs a discussion with the optimizer team.
+    */
+    /*
+    if (query.cond()->compare_type() == REAL_RESULT)
+    {
+      uint precise_digits= type() == MYSQL_TYPE_FLOAT ? 7 : 15;
+      if (query.item()->max_length > precise_digits)
+        return false;
+    }
+    */
+    return true;
+  }
+  return false;
+}
+
+
 /**
   Numeric fields base class constructor.
 */
@@ -1933,12 +1993,6 @@ int Field::store_time_dec(MYSQL_TIME *lt
 }
 
 
-bool Field::optimize_range(uint idx, uint part)
-{
-  return MY_TEST(table->file->index_flags(idx, part, 1) & HA_READ_RANGE);
-}
-
-
 Field *Field::new_field(MEM_ROOT *root, TABLE *new_table,
                         bool keep_type __attribute__((unused)))
 {
@@ -5256,6 +5310,31 @@ my_decimal *Field_temporal::val_decimal(
   return TIME_to_my_decimal(&ltime, d);
 }
 
+
+bool Field_temporal::can_optimize(const Tool &tool,
+                                  const Item_func *cond, const Item *arg)
+{
+  DBUG_ASSERT((tool.key_flags() & HA_SPATIAL) == 0);
+  if (cond->compare_type() != TIME_RESULT)
+    return false;
+  switch (tool.type())
+  {
+  case TOOL_KEYPART_RANGE:
+    return tool.optimize_range(table);
+  case TOOL_EQUALITY_FOR_OUTER_JOIN_TABLE_ELIMINATION:
+  case TOOL_KEY_GROUP_MIN_MAX:
+  case TOOL_PARTITION_RANGE:
+  case TOOL_KEYPART_RANGE_TRIVIAL:
+  case TOOL_KEYPART_REF:
+  case TOOL_PARTITION_REF:
+  case TOOL_HASH_JOIN:
+  case TOOL_SELECTIVITY:
+    return true;
+  }
+  return false;
+}
+
+
 /****************************************************************************
 ** time type
 ** In string context: HH:MM:SS
@@ -6462,6 +6541,72 @@ uint32 Field_longstr::max_data_length()
 }
 
 
+bool Field_longstr::can_optimize(const Tool &tool,
+                                 const Item_func *cond, const Item *arg)
+
+{
+  DBUG_ASSERT((tool.key_flags() & HA_SPATIAL) == 0);
+  DBUG_ASSERT(arg->result_type() == STRING_RESULT ||
+              arg->cmp_type() != STRING_RESULT);
+
+  if (cond->compare_type() != STRING_RESULT)
+    return false;
+
+  switch (tool.type())
+  {
+  case TOOL_KEYPART_RANGE:
+    if (!tool.optimize_range(table))
+      return false;
+    // Pass through
+  case TOOL_HASH_JOIN:
+  case TOOL_PARTITION_RANGE:
+  case TOOL_KEY_GROUP_MIN_MAX:
+    return charset() == cond->compare_collation();
+
+  case TOOL_EQUALITY_FOR_OUTER_JOIN_TABLE_ELIMINATION:
+    /*
+      A string column cannot be eliminated when compared as a number:
+        CREATE TABLE t1 (a INT PRIMARY KEY);
+        CREATE TABLE t2 (a VARCHAR(10) PRIMARY KEY);
+        SELECT t1.* FROM t1 LEFT JOIN t2 USING (a);
+      because unique string values '10' and '010' produce
+      non-unique val_int(), val_real(), val_decimal() results.
+
+      A string column cannot be eliminated when compared as date/time/datetime,
+      because unique string values can produce non-unique get_date() values:
+        '2001-10-10' and '2001/10/10' -> DATE'2001-10-10'
+        '10:10:10' and ' 10:10:10'    -> TIME'10:10:10'
+
+      A string column can be eliminated when compared as a string, only:
+      - if the collation of the operation is exactly the same with the
+        collation of the column;
+      - or if binary comparison is used.
+        These three queries return exactly the same set of rows:
+          SELECT DISTINCT primary_key_value FROM t2;
+          SELECT DISTINCT BINARY primary_key_value FROM t2;
+          SELECT DISTINCT primary_key_value COLLATE xxx_bin FROM t2;
+        So it should be safe to eliminate t2 from a LEFT JOIN in case
+        of binary comparison.
+    */
+  case TOOL_KEYPART_REF:
+  case TOOL_KEYPART_RANGE_TRIVIAL:
+  case TOOL_PARTITION_REF:
+  case TOOL_SELECTIVITY:
+    /*
+      Usually we can't use an index if the column collation
+      differ from the operation collation, with the exception that it's okey
+      to use any index (including case or accent insensitive indexes)
+      for binary equality:
+        WHERE latin1_swedish_ci_column = 'a' COLLATE lati1_bin
+        WHERE latin1_swedish_ci_colimn = BINARY 'a '
+    */
+    return (charset() == cond->compare_collation() ||
+           (cond->compare_collation()->state & MY_CS_BINSORT));
+  }
+  return false;
+}
+
+
 double Field_string::val_real(void)
 {
   ASSERT_COLUMN_MARKED_FOR_READ;
@@ -7923,6 +8068,38 @@ int Field_geom::store(const char *from,
   return -1;
 }
 
+
+bool Field_geom::can_optimize(const Tool &tool,
+                              const Item_func *cond, const Item *arg)
+
+{
+  if ((tool.key_flags() & HA_SPATIAL) == 0)
+  {
+    // Non spatial operation on a spatial column
+    return Field_blob::can_optimize(tool, cond, arg);
+  }
+
+  // @todo: use is_spatial_operator() instead?
+  switch (cond->functype()) {
+  case Item_func::SP_EQUALS_FUNC:
+  case Item_func::SP_DISJOINT_FUNC:
+  case Item_func::SP_INTERSECTS_FUNC:
+  case Item_func::SP_TOUCHES_FUNC:
+  case Item_func::SP_CROSSES_FUNC:
+  case Item_func::SP_WITHIN_FUNC:
+  case Item_func::SP_CONTAINS_FUNC:
+  case Item_func::SP_OVERLAPS_FUNC:
+    return true;
+  default:
+    /* 
+      We cannot involve spatial indexes for queries that
+      don't use MBREQUALS(), MBRDISJOINT(), etc. functions.
+    */
+    break;
+  }
+  return false;
+}
+
 #endif /*HAVE_SPATIAL*/
 
 /****************************************************************************
@@ -8366,6 +8543,68 @@ const uchar *Field_enum::unpack(uchar *t
 }
 
 
+bool Field_enum::can_optimize(const Tool &tool,
+                              const Item_func *cond, const Item *arg)
+{
+  DBUG_ASSERT((tool.key_flags() & HA_SPATIAL) == 0);
+
+  switch (tool.type())
+  {
+  case TOOL_EQUALITY_FOR_OUTER_JOIN_TABLE_ELIMINATION:
+  {
+    /*
+      We can't eliminate t2 in case of temporal data types in t1:
+        CREATE TABLE t1 (a DATE PRIMARY KEY);
+        CREATE TABLE t2 (a ENUM('2001-01-01','2001/01/01') PRIMARY KEY);
+        SELECT t1.* FROM t1 LEFT JOIN t2 USING (a);
+      because two different ENUM values '2001-01-01' and '2001/01/01'
+      map to the same DATE value '2001-01-01'. Disallow TIME_RESULT.
+
+      Allow all numeric data types (INT, REAL, DECIMAL results).
+      If a set of ENUM values is known to be unique, the set of its
+      val_int(), val_real() and val_decimal() values is also guaranteed
+      to be unique.
+      Allow string data types (STRING result) if the collation of the operation
+      is exactly the same with the collation of the field.
+    */
+    return (cond->compare_type() == STRING_RESULT &&
+            charset() == cond->compare_collation()) ||
+            cond->compare_type() == INT_RESULT ||
+            cond->compare_type() == REAL_RESULT ||
+            cond->compare_type() == DECIMAL_RESULT;
+  }
+  case TOOL_KEY_GROUP_MIN_MAX:
+    /*
+      Can't use GROUP_MIN_MAX optimization, because the values are stored
+      as numbers in index, while MIN() and MAX() work as strings.
+      It would return the records with min and max enum numeric indexes.
+      "Bug#45300 MAX() and ENUM type" should be fixed first.
+    */
+  case TOOL_KEYPART_RANGE:
+  case TOOL_PARTITION_RANGE:
+    return false;
+  case TOOL_KEYPART_RANGE_TRIVIAL:
+  case TOOL_KEYPART_REF:
+  case TOOL_PARTITION_REF:
+  case TOOL_HASH_JOIN:
+  case TOOL_SELECTIVITY:
+    /*
+      ENUM/SET do not allow ref access for TIME_RESULT conditions,
+      because multiple ENUM/SET values can map to the same temporal value:
+      Both values in ENUM('2010/01/01','2010-01-01') equal to DATE'2010-01-01'.
+      So the lines below do not include TIME_RESULT.
+      (these lines may slightly change after fixing MDEV-6993 though)
+    */
+    return (cond->compare_type() == STRING_RESULT &&
+            charset() == cond->compare_collation()) ||
+            arg->cmp_type() == INT_RESULT ||
+            arg->cmp_type() == DECIMAL_RESULT ||
+            arg->cmp_type() == REAL_RESULT;
+  }
+  return false;
+}
+
+
 /**
   @return
   returns 1 if the fields are equally defined

=== modified file 'sql/field.h'
--- sql/field.h	2014-10-20 12:42:00 +0000
+++ sql/field.h	2014-11-03 07:06:48 +0000
@@ -271,7 +271,182 @@ class Virtual_column_info: public Sql_al
   }
 };
 
-class Field
+
+class Item_func;
+
+class Field_optimizer
+{
+protected:
+  enum Tooltype
+  {
+    TOOL_KEYPART_REF,
+    TOOL_KEYPART_RANGE,
+    TOOL_KEYPART_RANGE_TRIVIAL,  // an empty range: a BETWEEN 1 AND 1
+    TOOL_KEY_GROUP_MIN_MAX,
+    TOOL_PARTITION_REF,
+    TOOL_PARTITION_RANGE,
+    TOOL_HASH_JOIN,
+    TOOL_EQUALITY_FOR_OUTER_JOIN_TABLE_ELIMINATION,
+    TOOL_SELECTIVITY
+  };
+
+  class Key_part
+  {
+    uint m_keyno;
+    uint m_partno;
+  public:
+    Key_part(uint keyno, uint partno)
+     :m_keyno(keyno), m_partno(partno)
+    { }
+    bool optimize_range(const TABLE *table) const
+    {
+      return table->optimize_range(m_keyno, m_partno);
+    }
+  };
+
+  class Tool
+  {
+  public:
+    virtual Tooltype type() const = 0;
+    virtual uint key_flags() const { return 0; }
+    virtual bool optimize_range(const TABLE *table) const { return false; }
+  };
+
+  class Tool_key: public Tool
+  {
+    const KEY *m_key;
+  public:
+    Tool_key(const KEY *key) :m_key(key) { }
+    const KEY *key() const { return m_key; }
+    uint key_flags() const { return m_key->flags; }
+  };
+
+  class Tool_key_group_min_max: public Tool_key
+  {
+  public:
+    Tool_key_group_min_max(const KEY *key) :Tool_key(key) { }
+    Tooltype type() const { return TOOL_KEY_GROUP_MIN_MAX; }
+  };
+
+  class Tool_keypart: public Tool_key, public Key_part
+  {
+  public:
+    Tool_keypart(const KEY *key, uint16 keyno, uint16 partno)
+      :Tool_key(key), Key_part(keyno, partno) { }
+    bool optimize_range(const TABLE *table) const
+    { return Key_part::optimize_range(table); }
+  };
+
+  class Tool_keypart_ref: public Tool_keypart
+  {
+  public:
+    Tool_keypart_ref(const KEY *key, uint16 keyno, uint16 partno):
+      Tool_keypart(key, keyno, partno) { }
+    Tooltype type() const { return TOOL_KEYPART_REF; }
+  };
+
+  class Tool_keypart_range: public Tool_keypart
+  {
+  public:
+    Tool_keypart_range(const KEY *key, uint16 keyno, uint16 parno)
+      :Tool_keypart(key, keyno, parno) { }
+    Tooltype type() const { return TOOL_KEYPART_RANGE; }
+  };
+
+  class Tool_keypart_range_trivial: public Tool_keypart
+  {
+  public:
+    Tool_keypart_range_trivial(const KEY *key, uint16 keyno, uint16 parno)
+      :Tool_keypart(key, keyno, parno) { }
+    Tooltype type() const { return TOOL_KEYPART_RANGE_TRIVIAL; }
+  };
+
+  class Tool_partition: public Tool
+  {
+    Tooltype m_type;
+  public:
+    Tool_partition(Tooltype type)
+      :m_type(type)
+    {
+      DBUG_ASSERT(type == TOOL_PARTITION_REF || type == TOOL_PARTITION_RANGE);
+    }
+    Tooltype type() const { return m_type; }
+  };
+
+  class Tool_selectivity: public Tool
+  {
+  public:
+    Tooltype type() const { return TOOL_SELECTIVITY; }
+  };
+
+  class Tool_hash_join: public Tool
+  {
+  public:
+    Tooltype type() const { return TOOL_HASH_JOIN; }
+  };
+
+  class Tool_equality_for_outer_join_table_elimination: public Tool
+  {
+  public:
+    Tooltype type() const
+    {
+      return TOOL_EQUALITY_FOR_OUTER_JOIN_TABLE_ELIMINATION;
+    }
+  };
+
+  virtual bool can_optimize(const Tool &tool,
+                            const Item_func *cond, const Item *arg) = 0;
+
+public:
+  bool can_optimize_keypart_ref(const KEY *key, uint keyno, uint partno,
+                                Item_func *cond, Item *item)
+  {
+    return can_optimize(Tool_keypart_ref(key, keyno, partno), cond, item);
+  }
+  bool can_optimize_keypart_range(const KEY *key, uint keyno, uint partno,
+                                  Item_func *cond, Item *item)
+  {
+    return can_optimize(Tool_keypart_range(key, keyno, partno), cond, item);
+  }
+  bool can_optimize_keypart_range_trivial(const KEY *key,
+                                          uint keyno, uint partno,
+                                          Item_func *cond, Item *item)
+  {
+    return can_optimize(Tool_keypart_range_trivial(key, keyno, partno),
+                                                   cond, item);
+  }
+  bool can_optimize_partition_ref(Item_func *cond, Item *item)
+  {
+    return can_optimize(Tool_partition(TOOL_PARTITION_REF), cond, item);
+  }
+  bool can_optimize_partition_range(Item_func *cond, Item *item)
+  {
+    return can_optimize(Tool_partition(TOOL_PARTITION_RANGE), cond, item);
+  }
+  bool can_optimize_key_group_min_max(const KEY *key,
+                                      Item_func *cond, Item *item)
+  {
+    return can_optimize(Tool_key_group_min_max(key), cond, item);
+  }
+  bool can_optimize_for_selectivity(Item_func *cond, Item *item)
+  {
+    return can_optimize(Tool_selectivity(), cond, item);
+  }
+  bool can_optimize_equality_for_outer_join_table_elimination(
+                                                          Item_func *cond,
+                                                          Item *item)
+  {
+    return can_optimize(Tool_equality_for_outer_join_table_elimination(),
+                        cond, item);
+  }
+  bool can_optimize_hash_join(Item_func *cond, Item *item)
+  {
+    return can_optimize(Tool_hash_join(), cond, item);
+  }
+};
+
+
+class Field: public Field_optimizer
 {
   Field(const Item &);				/* Prevent use of these */
   void operator=(Field &);
@@ -731,7 +906,6 @@ class Field
   void make_sort_key(uchar *buff, uint length);
   virtual void make_field(Send_field *);
   virtual void sort_string(uchar *buff,uint length)=0;
-  virtual bool optimize_range(uint idx, uint part);
   virtual void free() {}
   virtual Field *new_field(MEM_ROOT *root, TABLE *new_table,
                            bool keep_type);
@@ -850,16 +1024,6 @@ class Field
   { return binary() ? &my_charset_bin : charset(); }
   virtual CHARSET_INFO *sort_charset(void) const { return charset(); }
   virtual bool has_charset(void) const { return FALSE; }
-  /*
-    match_collation_to_optimize_range() is to distinguish in
-    range optimizer (see opt_range.cc) between real string types:
-      CHAR, VARCHAR, TEXT
-    and the other string-alike types with result_type() == STRING_RESULT:
-      DATE, TIME, DATETIME, TIMESTAMP
-    We need it to decide whether to test if collation of the operation
-    matches collation of the field (needed only for real string types).
-  */
-  virtual bool match_collation_to_optimize_range() const { return false; }
   virtual void set_charset(CHARSET_INFO *charset_arg) { }
   virtual enum Derivation derivation(void) const
   { return DERIVATION_IMPLICIT; }
@@ -952,6 +1116,7 @@ class Field
     return (double) 0.5; 
   }
 
+  bool can_optimize(const Tool &tool, const Item_func *cond, const Item *arg);
   friend int cre_myisam(char * name, register TABLE *form, uint options,
 			ulonglong auto_increment_value);
   friend class Copy_field;
@@ -1132,7 +1297,7 @@ class Field_longstr :public Field_str
 
   int store_decimal(const my_decimal *d);
   uint32 max_data_length() const;
-  bool match_collation_to_optimize_range() const { return true; }
+  bool can_optimize(const Tool &tool, const Item_func *cond, const Item *arg);
 };
 
 /* base class for float and double and decimal (old one) */
@@ -1560,6 +1725,11 @@ class Field_null :public Field_str {
   uint size_of() const { return sizeof(*this); }
   uint32 max_display_length() { return 4; }
   void move_field_offset(my_ptrdiff_t ptr_diff) {}
+  bool can_optimize(const Tool &tool, const Item_func *cond, const Item *arg)
+  {
+    DBUG_ASSERT(0);
+    return false;
+  }
 };
 
 
@@ -1592,6 +1762,7 @@ class Field_temporal: public Field {
   {
     return pos_in_interval_val_real(min, max);
   }
+  bool can_optimize(const Tool &tool, const Item_func *cond, const Item *arg);
 };
 
 
@@ -2551,7 +2722,6 @@ class Field_geom :public Field_blob {
   { geom_type= geom_type_arg; }
   enum ha_base_keytype key_type() const { return HA_KEYTYPE_VARBINARY2; }
   enum_field_types type() const { return MYSQL_TYPE_GEOMETRY; }
-  bool match_collation_to_optimize_range() const { return false; }
   void sql_type(String &str) const;
   int  store(const char *to, uint length, CHARSET_INFO *charset);
   int  store(double nr);
@@ -2566,6 +2736,7 @@ class Field_geom :public Field_blob {
   int reset(void) { return Field_blob::reset() || !maybe_null(); }
 
   geometry_type get_geometry_type() { return geom_type; };
+  bool can_optimize(const Tool &tool, const Item_func *cond, const Item *arg);
 };
 #endif /*HAVE_SPATIAL*/
 
@@ -2608,7 +2779,7 @@ class Field_enum :public Field_str {
   { return (field_metadata & 0x00ff); }
   uint row_pack_length() const { return pack_length(); }
   virtual bool zero_pack() const { return 0; }
-  bool optimize_range(uint idx, uint part) { return 0; }
+  bool can_optimize(const Tool &tool, const Item_func *cond, const Item *arg);
   bool eq_def(Field *field);
   bool has_charset(void) const { return TRUE; }
   /* enum and set are sorted as integers */

=== modified file 'sql/item.h'
--- sql/item.h	2014-11-01 21:08:09 +0000
+++ sql/item.h	2014-11-03 05:38:06 +0000
@@ -114,6 +114,11 @@ class DTCollation {
     derivation= derivation_arg;
     set_repertoire_from_charset(collation_arg);
   }
+  DTCollation(CHARSET_INFO *collation_arg, Derivation derivation_arg,
+              uint repertoire_arg)
+    :collation(collation_arg), derivation(derivation_arg),
+     repertoire(repertoire_arg)
+  { }
   void set(DTCollation &dt)
   { 
     collation= dt.collation;
@@ -1182,7 +1187,6 @@ class Item {
   virtual Item *get_tmp_table_item(THD *thd) { return copy_or_same(thd); }
 
   static CHARSET_INFO *default_charset();
-  virtual CHARSET_INFO *compare_collation() { return NULL; }
 
   /*
     For backward compatibility, to make numeric

=== modified file 'sql/item_cmpfunc.cc'
--- sql/item_cmpfunc.cc	2014-11-01 21:08:09 +0000
+++ sql/item_cmpfunc.cc	2014-11-03 07:27:47 +0000
@@ -140,8 +140,8 @@ static int cmp_row_type(Item* item1, Ite
   Aggregates result types from the array of items.
 
   SYNOPSIS:
-    agg_cmp_type()
-    type   [out] the aggregated type
+    set_compare_context()
+    name         name of the function, for error reporting
     items        array of items to aggregate the type from
     nitems       number of items in the array
 
@@ -159,13 +159,15 @@ static int cmp_row_type(Item* item1, Ite
     0  otherwise
 */
 
-static int agg_cmp_type(Item_result *type, Item **items, uint nitems)
+bool Hybrid_cmp_context::set_compare_context(const char *name,
+                                             Item **items,
+                                             uint nitems)
 {
   uint i;
-  type[0]= items[0]->cmp_type();
+  m_compare_type= items[0]->cmp_type();
   for (i= 1 ; i < nitems ; i++)
   {
-    type[0]= item_cmp_type(type[0], items[i]->cmp_type());
+    m_compare_type= item_cmp_type(m_compare_type, items[i]->cmp_type());
     /*
       When aggregating types of two row expressions we have to check
       that they have the same cardinality and that each component
@@ -173,10 +175,13 @@ static int agg_cmp_type(Item_result *typ
       the signature of the corresponding component of the second row
       expression.
     */ 
-    if (type[0] == ROW_RESULT && cmp_row_type(items[0], items[i]))
-      return 1;     // error found: invalid usage of rows
+    if (m_compare_type == ROW_RESULT && cmp_row_type(items[0], items[i]))
+      return true;     // error found: invalid usage of rows
   }
-  return 0;
+  if (m_compare_type == STRING_RESULT &&
+      agg_item_charsets_for_comparison(cmp_collation, name, items, nitems))
+    return true;
+  return false;
 }
 
 
@@ -537,26 +542,10 @@ void Item_bool_func2::fix_length_and_dec
   if (!args[0] || !args[1])
     return;
 
-  /* 
-    We allow to convert to Unicode character sets in some cases.
-    The conditions when conversion is possible are:
-    - arguments A and B have different charsets
-    - A wins according to coercibility rules
-    - character set of A is superset for character set of B
-   
-    If all of the above is true, then it's possible to convert
-    B into the character set of A, and then compare according
-    to the collation of A.
-  */
-
-  DTCollation coll;
-  if (args[0]->cmp_type() == STRING_RESULT &&
-      args[1]->cmp_type() == STRING_RESULT &&
-      agg_arg_charsets_for_comparison(coll, args, 2))
+  if (cmp.set_compare_context(func_name(), args, 2))
     return;
-    
-  args[0]->cmp_context= args[1]->cmp_context=
-    item_cmp_type(args[0]->result_type(), args[1]->result_type());
+
+  args[0]->cmp_context= args[1]->cmp_context= cmp.compare_type();
 
   /*
     Make a special case of compare with fields to get nicer comparisons
@@ -578,7 +567,10 @@ void Item_bool_func2::fix_length_and_dec
       if ((field_item->field_type() ==  MYSQL_TYPE_LONGLONG ||
            field_item->field_type() ==  MYSQL_TYPE_YEAR) &&
           convert_const_to_int(thd, field_item, &args[!field]))
+      {
         args[0]->cmp_context= args[1]->cmp_context= INT_RESULT;
+        cmp.set_compare_type(INT_RESULT);
+      }
     }
   }
   set_cmp_func();
@@ -591,6 +583,7 @@ int Arg_comparator::set_compare_func(Ite
   func= comparator_matrix[type]
                          [is_owner_equal_func()];
 
+  set_compare_type(type);
   switch (type) {
   case TIME_RESULT:
     cmp_collation.collation= &my_charset_numeric;
@@ -2247,11 +2240,8 @@ void Item_func_between::fix_length_and_d
   */
   if (!args[0] || !args[1] || !args[2])
     return;
-  if ( agg_cmp_type(&cmp_type, args, 3))
+  if (set_compare_context(func_name(), args, 3))
     return;
-  if (cmp_type == STRING_RESULT &&
-      agg_arg_charsets_for_comparison(cmp_collation, args, 3))
-   return;
 
   /*
     When comparing as date/time, we need to convert non-temporal values
@@ -2261,7 +2251,7 @@ void Item_func_between::fix_length_and_d
     For this to work, we need to know what date/time type we compare
     strings as.
   */
-  if (cmp_type ==  TIME_RESULT)
+  if (compare_type() ==  TIME_RESULT)
     compare_as_dates= find_date_time_item(args, 3, 0);
 
   /* See the comment about the similar block in Item_bool_func2 */
@@ -2275,7 +2265,7 @@ void Item_func_between::fix_length_and_d
       const bool cvt_arg1= convert_const_to_int(thd, field_item, &args[1]);
       const bool cvt_arg2= convert_const_to_int(thd, field_item, &args[2]);
       if (cvt_arg1 && cvt_arg2)
-        cmp_type=INT_RESULT;                    // Works for all types.
+        set_compare_type(INT_RESULT);                    // Works for all types.
     }
   }
 }
@@ -2285,7 +2275,7 @@ longlong Item_func_between::val_int()
 {
   DBUG_ASSERT(fixed == 1);
 
-  switch (cmp_type) {
+  switch (compare_type()) {
   case TIME_RESULT:
   {
     THD *thd= current_thd;
@@ -3993,7 +3983,7 @@ void Item_func_in::fix_length_and_dec()
   Item *date_arg= 0;
   uint found_types= 0;
   uint type_cnt= 0, i;
-  Item_result cmp_type= STRING_RESULT;
+  set_compare_type(STRING_RESULT);
   left_result_type= args[0]->cmp_type();
   if (!(found_types= collect_cmp_types(args, arg_count, true)))
     return;
@@ -4011,18 +4001,18 @@ void Item_func_in::fix_length_and_dec()
     if (found_types & (1U << i))
     {
       (type_cnt)++;
-      cmp_type= (Item_result) i;
+      set_compare_type((Item_result) i);
     }
   }
 
   if (type_cnt == 1)
   {
-    if (cmp_type == STRING_RESULT && 
+    if (compare_type() == STRING_RESULT && 
         agg_arg_charsets_for_comparison(cmp_collation, args, arg_count))
       return;
     arg_types_compatible= TRUE;
 
-    if (cmp_type == ROW_RESULT)
+    if (compare_type() == ROW_RESULT)
     {
       uint cols= args[0]->cols();
       cmp_item_row *cmp= 0;
@@ -4072,7 +4062,7 @@ void Item_func_in::fix_length_and_dec()
       See the comment about the similar block in Item_bool_func2
     */  
     if (args[0]->real_item()->type() == FIELD_ITEM &&
-        !thd->lex->is_view_context_analysis() && cmp_type != INT_RESULT)
+        !thd->lex->is_view_context_analysis() && compare_type() != INT_RESULT)
     {
       Item_field *field_item= (Item_field*) (args[0]->real_item());
       if (field_item->field_type() ==  MYSQL_TYPE_LONGLONG ||
@@ -4085,10 +4075,10 @@ void Item_func_in::fix_length_and_dec()
             all_converted= FALSE;
         }
         if (all_converted)
-          cmp_type= INT_RESULT;
+          set_compare_type(INT_RESULT);
       }
     }
-    switch (cmp_type) {
+    switch (compare_type()) {
     case STRING_RESULT:
       array=new in_string(arg_count-1,(qsort2_cmp) srtcmp_in, 
                           cmp_collation.collation);
@@ -4887,7 +4877,7 @@ longlong Item_func_like::val_int()
   null_value=0;
   if (canDoTurboBM)
     return turboBM_matches(res->ptr(), res->length()) ? 1 : 0;
-  return my_wildcmp(cmp.cmp_collation.collation,
+  return my_wildcmp(compare_collation(),
 		    res->ptr(),res->ptr()+res->length(),
 		    res2->ptr(),res2->ptr()+res2->length(),
 		    escape,wild_one,wild_many) ? 0 : 1;
@@ -4946,7 +4936,7 @@ bool Item_func_like::fix_fields(THD *thd
         return TRUE;
       }
 
-      if (use_mb(cmp.cmp_collation.collation))
+      if (use_mb(compare_collation()))
       {
         CHARSET_INFO *cs= escape_str->charset();
         my_wc_t wc;
@@ -4963,7 +4953,7 @@ bool Item_func_like::fix_fields(THD *thd
           code instead of Unicode code as "escape" argument.
           Convert to "cs" if charset of escape differs.
         */
-        CHARSET_INFO *cs= cmp.cmp_collation.collation;
+        CHARSET_INFO *cs= compare_collation();
         uint32 unused;
         if (escape_str->needs_conversion(escape_str->length(),
                                          escape_str->charset(), cs, &unused))
@@ -5270,7 +5260,7 @@ void Item_func_like::turboBM_compute_suf
   int            f = 0;
   int            g = plm1;
   int *const splm1 = suff + plm1;
-  CHARSET_INFO	*cs= cmp.cmp_collation.collation;
+  CHARSET_INFO	*cs= compare_collation();
 
   *splm1 = pattern_len;
 
@@ -5370,7 +5360,7 @@ void Item_func_like::turboBM_compute_bad
   int *end = bmBc + alphabet_size;
   int j;
   const int plm1 = pattern_len - 1;
-  CHARSET_INFO	*cs= cmp.cmp_collation.collation;
+  CHARSET_INFO	*cs= compare_collation();
 
   for (i = bmBc; i < end; i++)
     *i = pattern_len;
@@ -5402,7 +5392,7 @@ bool Item_func_like::turboBM_matches(con
   int shift = pattern_len;
   int j     = 0;
   int u     = 0;
-  CHARSET_INFO	*cs= cmp.cmp_collation.collation;
+  CHARSET_INFO	*cs= compare_collation();
 
   const int plm1=  pattern_len - 1;
   const int tlmpl= text_len - pattern_len;
@@ -5716,8 +5706,10 @@ Item *Item_bool_rowready_func2::negated_
   of the type Item_field or Item_direct_view_ref(Item_field). 
 */
 
-Item_equal::Item_equal(Item *f1, Item *f2, bool with_const_item)
-  : Item_bool_func(), eval_item(0), cond_false(0), cond_true(0), 
+Item_equal::Item_equal(const Hybrid_cmp_context context,
+                       Item *f1, Item *f2, bool with_const_item)
+  : Item_bool_func_hybrid_cmp_type(context),
+    eval_item(0), cond_false(0), cond_true(0), 
     context_field(NULL), link_equal_fields(FALSE)
 {
   const_item_cache= 0;
@@ -5743,8 +5735,9 @@ Item_equal::Item_equal(Item *f1, Item *f
 */
 
 Item_equal::Item_equal(Item_equal *item_equal)
-  : Item_bool_func(), eval_item(0), cond_false(0), cond_true(0),
-     context_field(NULL), link_equal_fields(FALSE)
+  : Item_bool_func_hybrid_cmp_type((Hybrid_cmp_context) *item_equal),
+    eval_item(0), cond_false(0), cond_true(0),
+    context_field(NULL), link_equal_fields(FALSE)
 {
   const_item_cache= 0;
   List_iterator_fast<Item> li(item_equal->equal_items);
@@ -6286,14 +6279,6 @@ void Item_equal::print(String *str, enum
 }
 
 
-CHARSET_INFO *Item_equal::compare_collation()
-{ 
-  Item_equal_fields_iterator it(*this);
-  Item *item= it++;
-  return item->collation.collation;
-}
-
-
 /*
   @brief Get the first equal field of multiple equality.
   @param[in] field   the field to get equal field to

